--this is the minimap button

function WhammyButton_OnLoad( self )
	self:RegisterForClicks("LeftButtonUp", "RightButtonUp");
	self:RegisterForDrag("RightButton");
	self.dragme = false;
end

function WhammyButton_OnDragStart( self )
	self.dragme = true;
end

function WhammyButton_OnDragStop( self )
	self.dragme = false;
end

function WhammyButton_OnUpdate( self )
	if (self.dragme == true) then
		WhammyButton_IconBeingDragged();
	end
end

function WhammyButton_OnEnter( self )
	GameTooltip:SetOwner(self, "ANCHOR_LEFT");
	GameTooltip:SetText("Whammy: v"..Whammy.version.."|n"..Whammy.localize.kmMiniMapButton_Text);
	GameTooltip:Show();
end

function WhammyButton_OnClick(self, ...)
	local arg1 = ...;

	if ( InCombatLockdown() ) then --if we we are incombat, don't allow hiding/showing of frames or other changes.
		UIErrorsFrame:AddMessage(WC_InCombatError, 1.0, 0.0, 0.0, 53, 5);
	else
		if ( arg1 == "LeftButton" and not IsShiftKeyDown() ) then --just a left click, show/hide the whammy frame
			Whammy:Slash_Command_Handler(""); --clcking the button is the same as typing /whammy, so use the same handler
		elseif ( arg1 == "LeftButton" and IsShiftKeyDown() ) then --a shift left click show the config frame
			WhammyConfig:Config_Frame_Toggle();
		elseif ( arg1 == "RightButton" and IsShiftKeyDown() ) then --shift right click, show the info/help frame
			Whammy:Info_Button_Click();
		end
	end
end

function WhammyButton_OnLeave(self)
	GameTooltip:Hide();
end

function WhammyButton_Move()
	local x = (82 * cos(W_Options.Angle))
	local y = (82 * sin(W_Options.Angle))
	W_MiniMap_ButtonFrame:SetPoint("CENTER","Minimap","CENTER", x,y);
end


-- local function createButton(name, object, db)
-- 	local button = CreateFrame("Button", "LibDBIcon10_"..name, Minimap)
-- 	button.dataObject = object
-- 	button.db = db
-- 	button:SetFrameStrata("MEDIUM")
-- 	button:SetWidth(31); button:SetHeight(31)
-- 	button:SetFrameLevel(8)
-- 	button:RegisterForClicks("anyUp")
-- 	button:RegisterForDrag("LeftButton")
-- 	button:SetHighlightTexture("Interface\\Minimap\\UI-Minimap-ZoomButton-Highlight")
-- 	local overlay = button:CreateTexture(nil, "OVERLAY")
-- 	overlay:SetWidth(53); overlay:SetHeight(53)
-- 	overlay:SetTexture("Interface\\Minimap\\MiniMap-TrackingBorder")
-- 	overlay:SetPoint("TOPLEFT")
-- 	local background = button:CreateTexture(nil, "BACKGROUND")
-- 	background:SetWidth(20); background:SetHeight(20)
-- 	background:SetTexture("Interface\\Minimap\\UI-Minimap-Background")
-- 	background:SetPoint("TOPLEFT", 7, -5)
-- 	local icon = button:CreateTexture(nil, "ARTWORK")
-- 	icon:SetWidth(17); icon:SetHeight(17)
-- 	icon:SetTexture(object.icon)
-- 	icon:SetPoint("TOPLEFT", 7, -6)
-- 	button.icon = icon
-- 	button.isMouseDown = false
-- 
-- 	icon.UpdateCoord = updateCoord
-- 	icon:UpdateCoord()
-- 
-- 	button:SetScript("OnEnter", onEnter)
-- 	button:SetScript("OnLeave", onLeave)
-- 	button:SetScript("OnClick", onClick)
-- 	if not db or not db.lock then
-- 		button:SetScript("OnDragStart", onDragStart)
-- 		button:SetScript("OnDragStop", onDragStop)
-- 	end
-- 	button:SetScript("OnMouseDown", onMouseDown)
-- 	button:SetScript("OnMouseUp", onMouseUp)
-- 
-- 	lib.objects[name] = button
-- 
-- 	if lib.loggedIn then
-- 		updatePosition(button)
-- 		if not db or not db.hide then button:Show()
-- 		else button:Hide() end
-- 	end
-- end


function WhammyButton_IconBeingDragged()
	--figure out what the angle is from the center of the map
	
	local xpos,ypos = GetCursorPosition() 
    local xmin,ymin = Minimap:GetLeft(), Minimap:GetBottom() 

    xpos = xmin-xpos/UIParent:GetScale()+82 
    ypos = ypos/UIParent:GetScale()-ymin-82
	
	local radians = -math.atan2(ypos,xpos); --get the angle (in degrees) of the x,y coords (rise, run format)
	local degrees = math.deg( radians ) - 180; --convert to degrees
	local degrees = math.floor(degrees)
	if ( degrees < 0 ) then
		degrees = 360 - math.abs(degrees)
	end
	
	W_Options.Angle = degrees

	WhammyConfigFrame.miniMapSlider:SetValue(W_Options.Angle);
	WhammyButton_Move();
end